﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Facebook;
using System.Text;
using System.IO.IsolatedStorage;
using Facebook_Tutorial_App.Models;
using System.Windows.Media.Imaging;

namespace Facebook_Tutorial_App
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();

            // Set the data context of the listbox control to the sample data
            DataContext = App.ViewModel;
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }



        // Load data for the ViewModel Items
        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (!App.ViewModel.IsDataLoaded)
            {
                App.ViewModel.LoadData();
            }
        }

        private FacebookClient _asyncFbClient;
        private string _appID = "get your own";
        private string _appSecret = "get your own";

        private void StartFacebookLogin(object sender, RoutedEventArgs e)
        {
            string[] extendedPermissions = new[] { "user_about_me", "publish_stream" };

            var oauth = new FacebookOAuthClient { AppId = _appID, AppSecret = _appSecret };
            var parameters = new Dictionary<string, object>
                            {
                                {"response_type", "token"},
                                {"display", "touch"}                                        
                            };
            if (extendedPermissions != null && extendedPermissions.Length > 0)
            {
                var scope = new StringBuilder();
                scope.Append(string.Join(",", extendedPermissions));
                parameters["scope"] = scope.ToString();
            }

            var loginUrl = oauth.GetLoginUrl(parameters);
            webBrowser.Navigated += new EventHandler<System.Windows.Navigation.NavigationEventArgs>(CheckForAuth);
            webBrowser.Navigate(loginUrl);
        }
        
        private void CheckForAuth(object sender, System.Windows.Navigation.NavigationEventArgs e)
        {
            FacebookOAuthResult result;
            if (FacebookOAuthResult.TryParse(e.Uri, out result))
            {
                if (result.IsSuccess)
                {
                    IsolatedStorageSettings Settings = IsolatedStorageSettings.ApplicationSettings;
                    if(Settings.Contains("MyFacebookAccessToken"))
                        Settings["MyFacebookAccessToken"] = result.AccessToken;
                    else 
                        Settings.Add("MyFacebookAccessToken", result.AccessToken);
                    Settings.Save();
                    _asyncFbClient = new FacebookClient(result.AccessToken);
                    _asyncFbClient.GetCompleted += new EventHandler<FacebookApiEventArgs>(_asyncFbClient_GetCompleted);
                    _asyncFbClient.GetAsync("/me");
                }
            }
        }

        void _asyncFbClient_GetCompleted(object sender, FacebookApiEventArgs e)
        {
            FacebookUser _fbUser = e.GetResultData<FacebookUser>();
            
            Deployment.Current.Dispatcher.BeginInvoke(() =>
            {
                fbName.Text = _fbUser.Name;
                BitmapImage bi = new BitmapImage(new Uri("https://graph.facebook.com/" + _fbUser.ID + "/picture"));
                fbAvatar.Source = bi;
                HideFacebookLogin.Begin();
            });
            _asyncFbClient.GetCompleted -= _asyncFbClient_GetCompleted;
        }
    }
}